#ifndef SERVOMOTEUR_H
#define SERVOMOTEUR_H

#include "barriere.h"
#include <Servo.h>

/*****************************************************
classe qui herite de barriere pour des barrieres avec servos
constructeur :
    servoa : un servo
    pina : la pin du servoa
    servob : un deuxième servo synchrone au premier (optionnel)
    pinb : la pin du servob si servob ajoute
    ferme : valeur basse de la duree du signal PWM (minimum 544us)
    ouvre : valeur haute de la duree du signal PWM (maximum 2400us)
    pas : vitesse de rotation en us
    duree  : duree de pause pour le servo
M�thodes redefinies :
    void ouverture() : ouvre la barriere
    void fermeture() : ferme la barriere
    void manoeuvre() : manoeuvre d'ouverture

**********************************************************/

class servomoteur : public barriere
{
    public:
        servomoteur();
        servomoteur(Servo& servoa,int pina, int ferme, int ouvre, int pas, int duree);
        servomoteur(Servo& servoa,int pina, Servo& servob, int pinb, int ferme, int ouvre, int pas, int duree);
        virtual ~servomoteur();
        // renvoie les pin de commande des barrieres
        int broche(int num) {if (doubleServo) {switch(num) {
                                                    case 1 : {return pin1; break;}
                                                    case 2 : {return pin2;break;}
                                                    default : return 0;
                                                        }
                                            }
                              else {if (num == 1) {return pin1;} else {return 0;}}
                            }
        // la methode ouverture de la barriere
        void ouverture();
        // la methode fermeture de la barriere
        void fermeture();
        // la methode manoeuvre de la barriere
        void manoeuvre();
    protected:
    private:
        int angle;
        int angleOuvre;
        int angleFerme;
        int _pas;
        Servo *servo1;
        Servo *servo2;
        bool doubleServo;
        int pin1;
        int pin2;
};

#endif // SERVOMOTEUR_H
